*
*	_ultoda.s: part of libhdi(high speed double integer library)
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif

	.text
	.even
.if	MPU>=68000
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
__ultoda_tab:
	.dc.l 1000000000
__ultoda_tab1:
	.dc.l 100000000
	.dc.l 10000000
	.dc.l 1000000
	.dc.l 100000
	.dc.l 10000
	.dc.l 1000
	.dc.l 100
	.dc.l 10
	.dc.l 0

~digit	.reg	d0
~tabval	.reg	d1
~value	.reg	d2
~tabptr	.reg	a0
~bufptr	.reg	a1

__ultoda::
	move.l	4(sp),~bufptr
	move.l	8(sp),~value
__ultoa_0:
	moveq.l	#9,~digit
	cmp.l	~value,~digit
	bcc.s	ultoa_conv_end
	lea	__ultoda_tab(pc),~tabptr
ultoa_search_tab:
	move.l	(~tabptr)+,~tabval
	cmp.l	~value,~tabval
	bhi.s	ultoa_search_tab
	bra.s	ultoa_set_digit

__ultoa_1:
	lea	__ultoda_tab1(pc),~tabptr
	move.l	(~tabptr)+,~tabval
	bra.s	ultoa_set_digit

ultoa_inc_digit:
	addq.b	#1,~digit
ultoa_sub_value:
	sub.l	~tabval,~value
	bcc.s	ultoa_inc_digit
	add.l	~tabval,~value
	move.b	~digit,(~bufptr)+
	move.l	(~tabptr)+,~tabval
	beq.s	ultoa_conv_end
ultoa_set_digit:
	move.b	#'0',~digit
	bra.s	ultoa_sub_value

ultoa_conv_end:
	add.b	#'0',~value
	move.b	~value,(~bufptr)+
	clr.b	(~bufptr)
	move.l	~bufptr,d0		* return end of string
	rts

	.even
.if	MPU>=68000
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
__ulltoda_tab:
	.dc.l -1981284352
	.dc.l -1966660860
	.dc.l -1486618624
	.dc.l 232830643
	.dc.l 1569325056
	.dc.l 23283064
	.dc.l 1874919424
	.dc.l 2328306
	.dc.l -1530494976
	.dc.l 232830
	.dc.l 276447232
	.dc.l 23283
	.dc.l 1316134912
	.dc.l 2328
	.dc.l -727379968
	.dc.l 232
	.dc.l 1215752192
	.dc.l 23
	.dc.l 1410065408
	.dc.l 2
	.dc.l 1000000000
	.dc.l 0

~valueH	.reg	d1
~tvalL	.reg	a2
~tvalH	.reg	d3

__ulltoda::
	move.l	12(sp),~valueH
	beq	__ultoda

	move.l	4(sp),~bufptr
	move.l	8(sp),~value
	lea	__ulltoda_tab(pc),~tabptr
	move.l	d3,-(sp)		* save reg
	bra.s	ulltoa_search_tab

ulltoa_search_tab0:
	addq.w	#8,~tabptr
ulltoa_search_tab:
*	move.l	(~tabptr)+,~tvalL
*	move.l	(~tabptr)+,~tvalH
*	cmp.l	~valueH,~tvalH		* valueH != 0 ͕ۏ؂Ă
	cmp.l	4(~tabptr),~valueH	* valueH != 0 ͕ۏ؂Ă
	blo.s	ulltoa_search_tab0
	bhi.s	ulltoa_set_tabval
*	cmp.l	~value,~tvalL
	cmp.l	0(~tabptr),~value
	bhs.s	ulltoa_set_tabval
	bra.s	ulltoa_search_tab0

ulltoa_inc_digit:
	addq.b	#1,~digit
ulltoa_sub_value:
	sub.l	~tvalL,~value
	subx.l	~tvalH,~valueH
	bcc.s	ulltoa_inc_digit
	add.l	~tvalL,~value
	addx.l	~tvalH,~valueH
	move.b	~digit,(~bufptr)+
	tst.l	~tvalH
	beq.s	ulltoa_conv_end
ulltoa_set_tabval:
	move.l	(~tabptr)+,~tvalL
	move.l	(~tabptr)+,~tvalH
ulltoa_set_digit:
	move.b	#'0',~digit
	bra.s	ulltoa_sub_value

ulltoa_conv_end:
	move.l	(sp)+,d3
	bra	__ultoa_1
	.end
