*
*	_ulltoha.s: part of libhdi(high speed double integer library)
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif

	.offset	4
cset	.ds.l	1
dst	.ds.l	1
src	.ds.l	1

~cset	.reg	a0
~dst	.reg	a1
~src	.reg	a2
~tmp	.reg	d0
~ch	.reg	d1
~cnt	.reg	d2

	.text
	.even
.if	MPU>=68000
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
__ultoha::
	movem.l	cset(sp),~cset/~dst/~src
ultoha_0:
	move.l	(~src),~tmp
	bne.s	ultoha_nz0
	move.b	#'0',(~dst)+
	clr.b	(~dst)
	move.l	~dst,d0
	rts

ultoha_nz0:
	moveq.l	#0,~tmp
	moveq.l	#3,~cnt
ultoha_nz0_skip:
	move.b	(~src)+,~ch
	dbne	~cnt,ultoha_nz0_skip
	move.b	~ch,~tmp
	lsr.b	#4,~tmp
	beq.s	ultoha_nz0_next
	move.b	(~cset,~tmp.w),(~dst)+
ultoha_nz0_next:
	moveq.l	#$0f,~tmp
	and.b	~ch,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	subq.w	#1,~cnt
	bcs.s	ultoha_nz0_end
ultoha_nz0_loop:
	move.b	(~src)+,~ch
	move.b	~ch,~tmp
	lsr.b	#4,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	moveq.l	#$0f,~tmp
	and.b	~ch,~tmp
	move.b	(~cset,~tmp.w),(~dst)+
	dbra	~cnt,ultoha_nz0_loop
ultoha_nz0_end:
	clr.b	(~dst)
	move.l	~dst,d0
	rts

.if	MPU>=68000
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
__ulltoha::
	movem.l	cset(sp),~cset/~dst/~src
	move.l	4(~src),~tmp
	beq.s	ultoha_0
ulltoha_nz0:
	addq.w	#4,~src
	bsr	ultoha_nz0
	subq.w	#8,~src
	moveq.l	#0,~tmp
	moveq.l	#3,~cnt
	bra.s	ultoha_nz0_loop
	.end
