/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * high speed patched by 씎Y(oo), HGG00736@niftyserve.or.jp
 */

/* System headers */
#include <stdlib.h>
#include "sys/xstdlib.h"

/* Functions */
char *fconvert (double x, int ndigit, int *decpt, int *sign, char *buffer)
{
    int pos, n;
    char *src, *dst;
    char string[24];

    /* 18̕ɕϊ */
    _dtos18 (x, decpt, sign, string);

    /* Rs[AhXݒ */
    src = string;

    /* Rs[AhXݒ */
    dst = buffer;

    /* _ʒu𓾂 */
    pos = *decpt;

    /* _ʒuȂ */
    if (pos < 0) {

	/* ߂錅vZ */
	n = min (-pos, ndigit);

	/* 擪0Ŗ߂ */
	while (n-- > 0)
	    *dst++ = '0';

	/* _ʒu0ɂȂ */
	*decpt = 0;

    }

    /* c̃Rs[ */
    n = ndigit + pos;

    /* i[ɃRs[ */
    while (n-- > 0) {

	/* Ȃ0Ŗ߂ */
	if (*src == '\0') {
	    while (n-- >= 0)
		*dst++ = '0';
	    break;
	}

	/* ϊ񂩂Rs[ */
	*dst++ = *src++;

    }

    /* I[ NUL ł */
    *dst = '\0';

    /* ۂ߂ */
    if (*src >= '5') {
        *decpt += _round (buffer, dst);
    }

    /* AhXԂ */
    return buffer;
}
