*
*	mul10di.s: part of libhdi(high speed double integer library)
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
	.globl ___mul10di
___mul10di:
	move.l	8(sp),d1
	bpl.s	___umul10di

	move.l	4(sp),d0
	neg.l	d0
	negx.l	d1
	bsr	___umul10di_exec
	neg.l	d0
	negx.l	d1
	rts

.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
	.globl ___umul10di
___umul10di:
valueL	.reg	d0
valueH	.reg	d1
tempL	.reg	a0
tempH	.reg	d2
	move.l	4(sp),valueL
	move.l	8(sp),valueH

___umul10di_exec:
	add.l	valueL,valueL
	addx.l	valueH,valueH	* value*2
	move.l	valueL,tempL
	move.l	valueH,tempH

	add.l	valueL,valueL
	addx.l	valueH,valueH	* value*4
	add.l	valueL,valueL
	addx.l	valueH,valueH	* value*8

	add.l	tempL,valueL
	addx.l	tempH,valueH	* value*2 + value*8
	rts
	.end
