*
*	muldf3.s: part of libhdi(high speed double integer library)
*	          based gnulib-1.46 mulsf3.s
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif

*
*	128bit  96bit ł́AقƂǓʂ𓾂̂
*	xʂ 96bit IL
*	ɂׂ̌̒ 64bit Őx͏\ȂƂ
*
PREC	.equ	64		* 128, 96 or 64

*
*	ROUND == 0 ƂƊۂ߂sR[h
*
ROUND	.equ	$200		* $000, $1ff or $200

*
*	fobOtO
*
DEBUG	.equ	0
.if	DEBUG
	.xref	_dumpregs
.endif

* Z̐x	 Prbg
*		w 11rbg
*		 53rbgix96rbgj
*

*///////////////////////////////////////
*
*	dr1.l * dr2.l  -> dr1:dr2
*
*	Faw1.l = dr1.l
*	jFdw1,dw2,dw3
*	xFQTU`RWSNbN
*
multl	macro	dr1,dr2,dw1,dw2,dw3,aw1

	move.l	dr2,dw1
	mulu.w	dr1,dr2		;dr1.low * dr2.low	ʁ~
	move.l	dw1,dw2		;dw1 = dw2 = dr2
	swap	dw1		;dw1 = dr2.hi
	mulu.w	dr1,dw1		;dr1.low * dr2.hi	ʁ~
	swap	dw1
	moveq.l	#0,dw3
	move.w	dw1,dw3		;dw3.l = dr1.low * dr2.hi ̏
	clr.w	dw1		;dw1.l = dr1.low * dr2.hi ̉ << 16
	add.l	dw1,dr2		;dw3:dr2 += 00:dw1
	moveq.l	#0,dw1
	addx.l	dw1,dw3
	swap	dr1
	mulu.w	dw2,dr1		;dr1.hi  * dr2.low	ʁ~
	swap	dr1
	moveq.l	#0,dw1
	move.w	dr1,dw1
	clr.w	dr1
	add.l	dr1,dr2
	addx.l	dw1,dw3
	swap	dw2
	move.l	aw1,dr1
	swap	dr1
	mulu.w	dw2,dr1		;dr1.hi  * dr2.hi	ʁ~
	add.l	dw3,dr1		;-> dr1:dr2
	endm
*///////////////////////////////////////

*///////////////////////////////////////
*
*	dr1.l * dr2.l -> dr1.l
*
*	jFdr2,dw1,dw2
*	xFPSU`QSQNbN
*
multlw	macro	dr1,dr2,dw1,dw2
	move.l	dr1,dw1		* dw1=dr1
	mulu.w	dr2,dr1		* dr2L * dr1L = dr1
	clr.w	dr1		* result LL ̂Ă
	swap	dr1		* result HL:LH

	move.l	dr2,dw2		* dw2=dr2
	swap	dw1		* dr1L:dr1H
	mulu.w	dw1,dr2		* dr1H * dr2L = dr2
	add.l	dr2,dr1		* result HL:LH

	swap	dw2		* dr2L:dr2H
	move.w	dw2,dr2		* dr2H
	swap	dw1		* dr1H:dr1L
	mulu.w	dw1,dr2		* dr1L * dr2H = dr2
	add.l	dr1,dr2		* result HL:LH
	moveq.l	#0,dr1
	roxl.l	#1,dr1		* get carry
	move.w	dr1,dr2
	swap	dr2		* result HH:HL

	move.l	dw1,dr1
	swap	dr1		* dr1H
	mulu.w	dw2,dr1		* dr2H * dr1H = dr1
	add.l	dr2,dr1
	endm
*///////////////////////////////////////

*///////////////////////////////////////
*
*	dr1.l * dr2.l -> dr1.l
*
*	jFdr2,dw1,dw2
*	xFPSU`QSQNbN
*
multw	macro	dr1,dr2,dw1,dw2
	move.l	dr1,dw1		* dw1=dr1
	swap	dr1		* dr1L:dr1H
	mulu.w	dr2,dr1		* dr2L*dr1H = dr1
	clr.w	dr1
	swap	dr1

	swap	dr2		* dr2L:dr2H
	move.w	dr2,dw2		* dw2.w=dr2H
	mulu.w	dw1,dr2		* dr1L*dr2H = dr2
	clr.w	dr2
	swap	dr2
	add.l	dr2,dr1		* result HL:LH

	swap	dw1		* dr1L:dr1H
	mulu.w	dw1,dw2		* dr1H*dr2H=dw2
	add.l	dw2,dr1
	endm
*///////////////////////////////////////

	.offset	4
df0H	ds.l	1
df0L	ds.l	1
df1H	ds.l	1
df1L	ds.l	1

~df0H	.reg	d0
~df1H	.reg	d1
~mask	.reg	d2
~df0e	.reg	d3
~df1e	.reg	d4
~save3	.reg	a0
~save4	.reg	a1

	.text
	.even
.if	MPU>=68020
.if	QUAD_ALIGN
	.quad
.endif
.endif
	.xdef	___muldf3
___muldf3:
	move.l	df0H(sp),~df0H
	move.l	df1H(sp),~df1H

	move.l	d3,~save3	* save regs
	move.l	d4,~save4
*
*	wo
*
*	in:	d0.l	{xȌʃO[h
*		d1.l	{xP̏ʃO[h
*
*	out:	d3.w	{xO̎wioCAX܂ށj
*		d4.w	{xP̎wioCAX܂ށj
*
	move.w	#$7ff0,~mask
	move.l	~df0H,~df0e
	swap	~df0e
	and.w	~mask,~df0e
	beq.s	quickReturnZero
	move.l	~df1H,~df1e
	swap	~df1e
	and.w	~mask,~df1e
	bne.s	calcExponent
quickReturnZero:
	move.l	~save4,d4
	move.l	~save3,d3
	moveq.l	#0,d0
	move.l	d0,d1
	rts

calcExponent:
*
*	wvZ
*
*	in:	d3.w	wOioCAX܂ށj
*		d4.w	wPioCAX܂ށj
*
*	out:	d3.w	w̘aioCAX܂ށj
*
	sub.w	#$3ff0,~df0e	* sub exponent bias
	add.w	~df1e,~df0e
	bvc.s	checkUnderflow
returnINF1:
	eor.l	~df0H,~df1H
	move.l	#$ffe00000,d0
	add.l	~df1H,~df1H
	roxr.l	#1,d0		* set sign bit
	moveq.l	#0,d1
	move.l	~save4,d4
	move.l	~save3,d3
	rts

checkUnderflow:
	ble.s	quickReturnZero

calcSign:
*
*	vZ
*
*	in:	d0.l	{xȌʃO[h
*		d1.l	{xP̏ʃO[h
*
*	out:	d3.l	vZʂ̕(ŏʃrbg)
*
~dfes	.reg	d3
~dfs	.reg	d4

	move.l	~df0H,~dfs	* reserve sign bit
	eor.l	~df1H,~dfs
	move.w	~dfes,~dfs	* ʂɃoCAXt̎w̒l
	move.l	~dfs,~dfes	* ŏʃrbg(bit31)ɕ
*
*	ʂo
*
~df0L	.reg	d2
~df1L	.reg	d4

	move.l	df0L(sp),~df0L
	move.l	df1L(sp),~df1L

*
*	o
*
*	in:	d0.l	{xȌʃO[h
*		d1.l	{xP̏ʃO[h
*
*	out:	a2.l	{xỎ
*		a3.l	{xỎ
*		a4.l	{xP̉
*		a5.l	{xP̉
*
~dv0H	.reg	a2
~dv0L	.reg	a3
~dv1H	.reg	a4
~dv1L	.reg	a5
.if	MPU<68020
~saves	.reg	d5-d7/a3-a5
.else
~saves	.reg	a3-a5
.endif
	movem.l	~saves,-(sp)		* ȍ~ d5-d7/a3-a5 g

	move.l	~df0L,~dv0L		* ʂҔ
	move.l	~df1L,~dv1L

	move.l	#$000fffff,~mask
	and.l	~mask,~df0H		* == ~dvH
	and.l	~mask,~df1H		* == ~dvL

~im11	.reg	d2

	move.l	~df1H,~dv0H		* ~df1H(~dvL) Ҕ
	moveq.l	#11,~im11		* Vtgrbg

~dvH	.reg	d0
~dvL	.reg	d1
~temp	.reg	d4

*	move.l	df0H(sp),~dvH
*	and.l	~mask,~dvH		* {xỎ
*	move.l	df0L(sp),~dvL		* {xỎ
	move.l	~dv0L,~dvL
	move.l	~dvL,~temp		* ~temp=~dvLH:~dvLL
	move.w	~dvH,~temp		* ~temp=~dvLH:~dvHL
	swap	~temp			* ~temp=~dvHL:~dvLH
	lsl.l	~im11,~dvL		* ~dvL <<= 11
	lsl.l	~im11,~temp		* ~dvHL:~dvLH <<= 11
	lsl.l	~im11,~dvH		* ~dvH <<= 11
	swap	~temp
	move.w	~temp,~dvH
	bset.l	#31,~dvH		* ŏʃrbgĂ

	exg.l	~dvH,~dv0H		* {xỎ
	move.l	~dvL,~dv0L		* {xỎ

*	move.l	df1H(sp),~dvH
*	and.l	~mask,~dvH		* {xỎ
*	move.l	df1L(sp),~dvL		* {xP̉
	move.l	~dv1L,~dvL
	move.l	~dvL,~temp		* ~temp=~dvLH:~dvLL
	move.w	~dvH,~temp		* ~temp=~dvLH:~dvHL
	swap	~temp			* ~temp=~dvHL:~dvLH
	lsl.l	~im11,~dvL		* ~dvL <<= 11
	lsl.l	~im11,~temp		* ~dvHL:~dvLH <<= 11
	lsl.l	~im11,~dvH		* ~dvH <<= 11
	swap	~temp
	move.w	~temp,~dvH
	bset.l	#31,~dvH		* ŏʃrbgĂ

	move.l	~dvH,~dv1H
	move.l	~dvL,~dv1L

.if	DEBUG
	movem.l	d0-d7/a0-a5,-(sp)
	movem.l	d0-d7/a0-a5,-(sp)
	bsr	_dumpregs
	movem.l	(sp)+,d0-d7/a0-a5
	movem.l	(sp)+,d0-d7/a0-a5
.endif
*
*	vZ
*
~dr1	.reg	d2
~dr2	.reg	d4
.if	MPU<68020
~dw1	.reg	d5
~dw2	.reg	d6
~dw3	.reg	d7
.endif

.if	PREC=128
*
*	~dv0L(a3) * ~dv1L(a5)
*
	moveq.l	#0,~dr1
	move.l	~dv1L,~dr2
	beq.s	skipLL
	move.l	~dv0L,~dr1
	beq.s	@f
.if	MPU<68020
	multl	~dr1,~dr2,~dw1,~dw2,~dw3,~dv0L		* ~dr1:~dr2
.else
	mulu.l	~dr2,~dr2:~dr1
.endif
@@:
	moveq.l	#0,~dr2					* ŉʂ͎̂Ă
skipLL:
.endif

*
*	~dv0H(a2) * ~dv1L(a5)
*	ZI  ~dv1L(a5) ͋󂫃WX^ƂȂ
*
.if	PREC=128
	moveq.l	#0,~dvH
	move.l	~dv1L,~dvL
	beq.s	skipHL
	move.l	~dv0H,~dvH	* ~dv0H != 0
.if	MPU<68020
	multl	~dvH,~dvL,~dw1,~dw2,~dw3,~dv0H		* ~dvH:~dvL
.else
	mulu.l	~dvH,~dvH:~dvL
.endif
*
*	ffff_ffff * ffff_ffff = ffff_fffe_0000_0001
*     +)ffff_ffff * ffff_ffff =           ffff_fffe_0000_0001
*     =======================================================
*                               ffff_fffe_ffff_ffff_0000_0001	]ăL[͂Ȃ
skipHL:
	add.l	~dr1,~dvL
	addx.l	~dr2,~dvH
.else
.if	PREC=96
	moveq.l	#0,~dvH
	move.l	~dv1L,~dvL
	beq.s	skipHL
	move.l	~dv0H,~dvH		* ~dv0H != 0
.if	MPU<68020
	multlw	~dvH,~dvL,~dw1,~dw2
.else
	mulu.l	~dvH,~dvH:~dvL
.endif
	moveq.l	#0,~dvL
skipHL:
.else
	moveq.l	#0,~dvH
	move.l	~dv1L,~dvL
	beq.s	skipHL
	move.l	~dv0H,~dvH		* ~dv0H != 0
.if	MPU<68020
	multw	~dvH,~dvL,~dw1,~dw2
.else
	mulu.l	~dvH,~dvH:~dvL
.endif
	moveq.l	#0,~dvL
skipHL:
.endif
.endif
*
*	~dv0L(a3) * ~dv1H(a4)
*	ZI  ~dv0L(a3) ͋󂫃WX^ƂȂ
*
.if	PREC=128
	moveq.l	#0,~dr2
	move.l	~dv0L,~dr1
	beq.s	skipLH
	move.l	~dv1H,~dr2	* ~dv1H != 0
.if	MPU<68020
	multl	~dr1,~dr2,~dw1,~dw2,~dw3,~dv0L		* ~dr1:~dr2
.else
	mulu.l	~dr1,~dr1:~dr2
.endif
skipLH:
	add.l	~dvL,~dr2
	addx.l	~dvH,~dr1
	moveq.l	#0,~dr2
	roxl.l	#1,~dr2		* get carry
.else
.if	PREC=96
	moveq.l	#0,~dr1
	move.l	~dv0L,~dr2
	beq.s	skipLH
	move.l	~dv1H,~dr1	* ~dv1H != 0
.if	MPU<68020
	multlw	~dr1,~dr2,~dw1,~dw2
.else
	mulu.l	~dr1,~dr1:~dr2
.endif
	moveq.l	#0,~dr2
skipLH:
	add.l	~dvH,~dr1
	addx.l	~dvL,~dr2
.else
	moveq.l	#0,~dr1
	move.l	~dv0L,~dr2
	beq.s	skipLH
	move.l	~dv1H,~dr1	* ~dv1H != 0
.if	MPU<68020
	multw	~dr1,~dr2,~dw1,~dw2
.else
	mulu.l	~dr1,~dr1:~dr2
.endif
	moveq.l	#0,~dr2
skipLH:
	add.l	~dvH,~dr1
	addx.l	~dvL,~dr2
.endif
.endif
*
*	~dv0H(a2) * ~dv1H(a4)
*	ZI  ~dv0H(a2), ~dv0H(a4) ͋󂫃WX^ƂȂ
*
	move.l	~dv0H,~dvH
	move.l	~dv1H,~dvL
.if	MPU<68020
	multl	~dvH,~dvL,~dw1,~dw2,~dw3,~dv0H		* ʂ̍ŏ ~dvH:~dvL
.else
	mulu.l	~dvH,~dvH:~dvL
.endif

	add.l	~dr1,~dvL
	addx.l	~dr2,~dvH

.if	ROUND
*
*	ۂ߂s
*
	move.l	#ROUND,~dr1
	moveq.l	#0,~dr2
	add.l	~dr1,~dvL
	addx.l	~dr2,~dvH
.endif
.if	DEBUG
	movem.l	d0-d7/a0-a5,-(sp)
	movem.l	d0-d7/a0-a5,-(sp)
	bsr	_dumpregs
	movem.l	(sp)+,d0-d7/a0-a5
	movem.l	(sp)+,d0-d7/a0-a5
.endif
*
*	𐳋K
*
*	in:	d0.l(dvH)	̏ 32bit
*		d1.1(dvL)	̉ 32bit
*
	tst.l	~dvH
	bpl.s	rightShift10bit
rightShift11bit:
	add.w	#$0010,~dfes
	bvs.s	returnINF2
	ble.s	returnZero	* underflow
	lsr.l	#1,~dvH
	roxr.l	#1,~dvL

rightShift10bit:
*
*	10 bit EVtg
*
~im10	.reg	d2

	moveq.l	#10,~im10
	move.l	~dvL,~temp	* ~dvLH:~dvLL
	move.w	~dvH,~temp	* ~dvLH:~dvHL
	swap	~temp		* ~dvHL:~dvLH
	lsr.l	~im10,~dvH
	lsr.l	~im10,~temp
	lsr.l	~im10,~dvL
	swap	~dvL		* ~dvLL:~dvLH
	move.w	~temp,~dvL
	swap	~dvL
	bclr.l	#20,~dvH		*  1. 
setExponent:
	swap	~dvH
	or.w	~dfes,~dvH
	tst.l	~dfes			* ŏʂɕ
	bpl.s	getResult
	bset	#15,~dvH
getResult:
	swap	~dvH
*
*	ʂԂ
*
	movem.l	(sp)+,~saves
	move.l	~save4,d4
	move.l	~save3,d3
	rts

returnZero
	moveq.l	#0,d0
	move.l	d0,d1
	add.l	~dfes,~dfes
	roxr.l	#1,d0		* set sign bit
	movem.l	(sp)+,~saves
	move.l	~save4,d4
	move.l	~save3,d3
	rts

returnINF2
	move.l	#$ffe00000,d0
	add.l	~dfes,~dfes
	roxr.l	#1,d0		; set sign bit
	moveq.l	#0,d1
	movem.l	(sp)+,~saves
	move.l	~save4,d4
	move.l	~save3,d3
	rts
	.end
