/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * high speed patched by 씎Y(oo), HGG00736@niftyserve.or.jp
 */

/* System headers */
#include <stdlib.h>
#include <string.h>
#include <sys/xmath.h>
#include "sys/xstdlib.h"

/* File scope variables */
static char floating[512];

/* Functions */
char *_ecvt (double value, int precision, int *dec, int *sign)
{
    /* _ E Format ŕϊ */
    return econvert (value, precision, dec, sign, floating);
}

/* Functions */
char *_fcvt (double value, int precision, int *dec, int *sign)
{
    /* _ F Format ŕϊ */
    return fconvert (value, precision, dec, sign, floating);
}
