*
*	_ulltoxa.s: part of libhdi(high speed double integer library)
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif

	.text
	.even
.if	MPU>=68000
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
__ulltoxa_jmpcnt:
*		  0   1   2   3   4   5   6   7
	.dc.b	$20,$18,$14,$10,$0c,$08,$04,$00
	.even
.if	MPU>=68000
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif

~value	.reg	d0
~shift	.reg	d1
~mask	.reg	d2
~temp	.reg	d3
~valueH	.reg	d4
~cset	.reg	a0
~buffer	.reg	a1
~save	.reg	a2

*
* char* _ulltoxa(char* buffer, int shift, int mask, const char* cset, unsigned long long value)
*
	.globl __ulltoxa
__ulltoxa:
	move.l	24(sp),~value
	beq.s	__ultoxa
	movem.l	4(sp),~value/~shift/~mask/~cset/~buffer
	exg.l	~buffer,~value
	move.l	~temp,~save		* save reg
	move.l	~valueH,-(sp)
	move.l	28(sp),~valueH
	move.b	(__ulltoxa_jmpcnt,pc,~shift.w),~shift
	moveq.l	#0,~temp

ulltoxa_conv_loop:
	move.b	~value,~temp
	and.b	~mask,~temp
	move.b	(~cset,~temp.w),-(~buffer)
	jmp	(ulltoxa_jmpbase,pc,~shift.w)
ulltoxa_jmpbase:
	lsr.l	#1,~valueH		* 7
	roxr.l	#1,~value
	lsr.l	#1,~valueH		* 6
	roxr.l	#1,~value
	lsr.l	#1,~valueH		* 5
	roxr.l	#1,~value
	lsr.l	#1,~valueH		* 4
	roxr.l	#1,~value
	lsr.l	#1,~valueH		* 3
	roxr.l	#1,~value
	lsr.l	#1,~valueH		* 2
	roxr.l	#1,~value
	lsr.l	#1,~valueH		* 1
	beq.s	ulltoxa_conv_end
	roxr.l	#1,~value
	bra.s	ulltoxa_conv_loop

ulltoxa_conv_end:
	roxr.l	#1,~value		* Oɂ͂ȂȂ
	move.l	(sp)+,~valueH
	move.l	8(sp),~shift
	bra.s	ultoxa_conv_loop

.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
*
* char* _ultoxa(char* buffer, int shift, int mask, const char* cset, unsigned long value)
*
	.globl __ultoxa
__ultoxa:
	movem.l	4(sp),~value/~shift/~mask/~cset/~buffer
	exg.l	~buffer,~value
	move.l	~temp,~save		* save reg
	moveq.l	#0,~temp

ultoxa_conv_loop:
	move.b	~value,~temp
	and.b	~mask,~temp
	move.b	(~cset,~temp.w),-(~buffer)
	lsr.l	~shift,~value
	bne.s	ultoxa_conv_loop

	move.l	~save,~temp		* restore reg
	move.l	~buffer,d0		* return buffer
	rts

	.end
